"use strict";
this.name           = "doomed_stardestroyer";
this.author         = "GGShinobi";
this.copyright      = "© 2013 GGShinobi, Creative Commons: attribution, non-commercial, sharealike.";
this.description    = "some special actions for the stardestroyer.";
this.version        = "0.0.0";

// detonate subentites.
// uses this.$number2BlowUp
this.$detonateSubents = function() {
  for (subent in this.subEntities) {
    if (this.$number2BlowUp === 0 || ! this.subEntities[subent]) return;
    this.subEntities[subent].explode();
    this.$number2BlowUp--;
  }
}

// make the death a little more spectacular by detonating the subentities:
// detonate subentites every 0.5 seconds
// params: doomedStarDestroyer: the ship of which the entities are to be blown up
this.$startSubDetonations = function(doomedStarDestroyer) {
  if (doomedStarDestroyer.subEntities) {
    doomedStarDestroyer.$number2BlowUp = doomedStarDestroyer.subEntities.length/8;
    // 5 seconds countdown till detonation, but Timer starts only after 1 second => 4 (* 2 -> every 0.5 seconds)
    doomedStarDestroyer.$detonationTimer = new Timer(doomedStarDestroyer, doomedStarDestroyer.$detonateSubents, 1, 0.5);
    log("doomed stardestroyer", this + ": number2BlowUp: " + doomedStarDestroyer.$number2BlowUp + " (subentities: " + doomedStarDestroyer.subEntities.length + ")");
  } else {
    log("doomed stardestroyer", ship + ": has no subentities.");
  }
  doomedStarDestroyer.entityDestroyed = function() {
    log(this, "cleaning up detonation timer: ", this.$detonationTimer);
    if (this.$detonationTimer) {
      if (this.$detonationTimer.isRunning) this.$detonationTimer.stop();
      delete this.$detonationTimer;
    }
  }
}

// cleanup after ship has been destroyed
this.entityDestroyed = function() {
  log(this, "cleaning up detonation timer: ", this.$detonationTimer);
  if (this.$detonationTimer) {
    if (this.$detonationTimer.isRunning) this.$detonationTimer.stop();
    delete this.$detonationTimer;
  }
}
